package netscape.ldap;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import netscape.ldap.ber.stream.BERConstruct;
import netscape.ldap.ber.stream.BERSequence;

public class LDAPControl implements Cloneable {
   public static final String MANAGEDSAIT = "2.16.840.1.113730.3.4.2";
   public static final String PWEXPIRED = "2.16.840.1.113730.3.4.4";
   public static final String PWEXPIRING = "2.16.840.1.113730.3.4.5";
   private String m_oid;
   protected boolean m_critical = false;
   protected byte[] m_value;

   public LDAPControl() {
   }

   public LDAPControl(String var1, boolean var2, byte[] var3) {
      this.m_oid = var1;
      this.m_critical = var2;
      this.m_value = var3;
   }

   public String getID() {
      return this.m_oid;
   }

   public boolean isCritical() {
      return this.m_critical;
   }

   public byte[] getValue() {
      return this.m_value;
   }

   public Object clone() {
      byte[] var1 = null;
      if (this.m_value != null) {
         var1 = new byte[this.m_value.length];

         for(int var2 = 0; var2 < this.m_value.length; ++var2) {
            var1[var2] = this.m_value[var2];
         }
      }

      LDAPControl var3 = new LDAPControl(this.m_oid, this.m_critical, var1);
      return var3;
   }

   protected byte[] flattenBER(BERSequence var1) {
      ByteArrayOutputStream var2 = new ByteArrayOutputStream();

      try {
         ((BERConstruct)var1).write(var2);
      } catch (IOException var3) {
         return null;
      }

      return var2.toByteArray();
   }
}
