package netscape.ldap;

import netscape.ldap.client.JDAPMessage;

class LDAPResponseListener {
   private JDAPMessage response;
   private LDAPException exception;
   private boolean responseReceived;
   private boolean exceptionOccured;
   // $FF: renamed from: me java.lang.Thread
   private Thread field_0;
   private LDAPControl[] controls;
   private LDAPConnection connection;
   // $FF: renamed from: id int
   private int field_1;

   public LDAPResponseListener(LDAPConnection var1) {
      this.connection = var1;
      this.reset();
   }

   synchronized JDAPMessage getResponse() throws LDAPException {
      while(!this.responseReceived) {
         try {
            this.wait();
         } catch (InterruptedException var1) {
         }
      }

      if (this.exceptionOccured) {
         throw this.exception;
      } else {
         return this.response;
      }
   }

   synchronized void setResponse(JDAPMessage var1) {
      this.response = var1;
      this.responseReceived = true;
      this.notifyAll();
   }

   synchronized void setException(LDAPException var1) {
      this.exceptionOccured = true;
      this.responseReceived = true;
      this.exception = var1;
      this.notifyAll();
   }

   boolean isResponseReceived() {
      return this.responseReceived;
   }

   void reset() {
      this.responseReceived = false;
      this.exceptionOccured = false;
      this.field_0 = null;
   }

   void setThread() {
      this.field_0 = Thread.currentThread();
   }

   Thread getThread() {
      return this.field_0;
   }

   LDAPConnection getConnection() {
      return this.connection;
   }

   int getID() {
      return this.field_1;
   }

   void setID(int var1) {
      this.field_1 = var1;
   }
}
