package netscape.ldap;

import java.net.Socket;

public class LDAPSSLSocketWrapFactory implements LDAPSSLSocketFactoryExt {
   private boolean m_clientAuth = false;
   private String m_packageName;
   private Object m_cipherSuites;

   public LDAPSSLSocketWrapFactory(String var1) {
      this.m_packageName = new String(var1);
   }

   public LDAPSSLSocketWrapFactory(String var1, Object var2) {
      this.m_packageName = new String(var1);
      this.m_cipherSuites = var2;
   }

   public Socket makeSocket(String var1, int var2) throws LDAPException {
      Object var3 = null;

      try {
         LDAPSSLSocket var6;
         if (this.m_cipherSuites == null) {
            var6 = new LDAPSSLSocket(var1, var2, this.m_packageName);
         } else {
            var6 = new LDAPSSLSocket(var1, var2, this.m_packageName, this.m_cipherSuites);
         }

         return var6;
      } catch (Exception var5) {
         System.err.println("Exception: " + ((Throwable)var5).toString());
         throw new LDAPException("Failed to create SSL socket", 91);
      }
   }

   public boolean isClientAuth() {
      return this.m_clientAuth;
   }

   public void enableClientAuth() throws LDAPException {
      throw new LDAPException("Client Authentication is not implemented yet.");
   }

   public String getSSLSocketImpl() {
      return this.m_packageName;
   }

   public Object getCipherSuites() {
      return this.m_cipherSuites;
   }
}
