package netscape.ldap;

import java.util.Enumeration;
import java.util.Vector;
import netscape.ldap.client.JDAPMessage;

class LDAPSearchListener extends LDAPResponseListener {
   private Vector searchResults;
   private Long m_key;
   private LDAPSearchConstraints m_constraints;

   LDAPSearchListener(LDAPConnection var1, LDAPSearchConstraints var2) {
      super(var1);
      this.m_constraints = var2;
      this.searchResults = new Vector();
   }

   synchronized void addSearchResult(JDAPMessage var1) {
      this.searchResults.addElement(var1);
      this.notifyAll();
   }

   Enumeration getSearchResults() {
      return this.searchResults.elements();
   }

   int getCount() {
      return this.searchResults.size();
   }

   void reset() {
      super.reset();
      if (this.searchResults != null) {
         this.searchResults.removeAllElements();
      }

   }

   JDAPMessage nextResult() {
      synchronized(this){}

      JDAPMessage var1;
      try {
         while(true) {
            if (this.searchResults.size() >= 1) {
               var1 = (JDAPMessage)this.searchResults.elementAt(0);
               this.searchResults.removeElementAt(0);
               break;
            }

            if (((LDAPResponseListener)this).isResponseReceived()) {
               this.searchResults.removeAllElements();
               Object var2 = null;
               return (JDAPMessage)var2;
            }

            try {
               this.wait();
            } catch (InterruptedException var7) {
            }
         }
      } catch (Throwable var8) {
         throw var8;
      }

      ((LDAPResponseListener)this).getConnection().resultRetrieved();
      return var1;
   }

   LDAPSearchConstraints getConstraints() {
      return this.m_constraints;
   }

   void setKey(Long var1) {
      this.m_key = var1;
   }

   Long getKey() {
      return this.m_key;
   }
}
