package netscape.ldap.client;

import java.util.Vector;
import netscape.ldap.ber.stream.BERConstruct;
import netscape.ldap.ber.stream.BERElement;
import netscape.ldap.ber.stream.BEROctetString;
import netscape.ldap.ber.stream.BERSequence;
import netscape.ldap.ber.stream.BERTag;

public class JDAPFilterSubString extends JDAPFilter {
   private String m_type;
   private Vector m_initial = new Vector();
   private Vector m_any = new Vector();
   private Vector m_final = new Vector();

   public JDAPFilterSubString(String var1) {
      this.m_type = var1;
   }

   public void addInitial(String var1) {
      this.m_initial.addElement(var1);
   }

   public void addAny(String var1) {
      this.m_any.addElement(var1);
   }

   public void addFinal(String var1) {
      this.m_final.addElement(var1);
   }

   public BERElement getBERElement() {
      BERSequence var1 = new BERSequence();
      ((BERConstruct)var1).addElement(new BEROctetString(this.m_type));
      BERSequence var2 = new BERSequence();

      for(int var3 = 0; var3 < this.m_initial.size(); ++var3) {
         String var4 = (String)this.m_initial.elementAt(var3);
         if (var4 != null) {
            BERTag var5 = new BERTag(128, JDAPFilterOpers.getOctetString(var4), true);
            ((BERConstruct)var2).addElement(var5);
         }
      }

      for(int var8 = 0; var8 < this.m_any.size(); ++var8) {
         String var9 = (String)this.m_any.elementAt(var8);
         if (var9 != null) {
            BERTag var6 = new BERTag(129, JDAPFilterOpers.getOctetString(var9), true);
            ((BERConstruct)var2).addElement(var6);
         }
      }

      for(int var10 = 0; var10 < this.m_final.size(); ++var10) {
         String var11 = (String)this.m_final.elementAt(var10);
         if (var11 != null) {
            BERTag var7 = new BERTag(130, JDAPFilterOpers.getOctetString(var11), true);
            ((BERConstruct)var2).addElement(var7);
         }
      }

      ((BERConstruct)var1).addElement(var2);
      BERTag var12 = new BERTag(164, var1, true);
      return var12;
   }

   public String toString() {
      String var1 = "";

      for(int var2 = 0; var2 < this.m_initial.size(); ++var2) {
         if (var2 != 0) {
            var1 = var1 + ",";
         }

         var1 = var1 + (String)this.m_initial.elementAt(var2);
      }

      String var3 = "";

      for(int var4 = 0; var4 < this.m_any.size(); ++var4) {
         if (var4 != 0) {
            var3 = var3 + ",";
         }

         var3 = var3 + (String)this.m_any.elementAt(var4);
      }

      String var5 = "";

      for(int var6 = 0; var6 < this.m_final.size(); ++var6) {
         if (var6 != 0) {
            var5 = var5 + ",";
         }

         var5 = var5 + (String)this.m_final.elementAt(var6);
      }

      return "JDAPFilterSubString {type=" + this.m_type + ", initial=" + var1 + ", any=" + var3 + ", final=" + var5 + "}";
   }
}
