package netscape.ldap.client.opers;

import java.io.IOException;
import netscape.ldap.ber.stream.BERConstruct;
import netscape.ldap.ber.stream.BERElement;
import netscape.ldap.ber.stream.BEROctetString;
import netscape.ldap.ber.stream.BERSequence;
import netscape.ldap.ber.stream.BERTag;

public class JDAPBindResponse extends JDAPResult implements JDAPProtocolOp {
   protected String m_credentials;

   public JDAPBindResponse(BERElement var1) throws IOException {
      super(((BERTag)var1).getValue());
      BERSequence var2 = (BERSequence)((BERTag)var1).getValue();
      if (((BERConstruct)var2).size() > 3) {
         BERElement var3 = ((BERConstruct)var2).elementAt(3);
         if (var3.getType() == -1) {
            BEROctetString var4 = (BEROctetString)((BERTag)var3).getValue();

            try {
               this.m_credentials = new String(var4.getValue(), "UTF8");
            } catch (Throwable var5) {
            }
         }
      }
   }

   public String getCredentials() {
      return this.m_credentials;
   }

   public int getType() {
      return 1;
   }

   public String toString() {
      return "JDAPBindResponse " + super.getParamString();
   }
}
